package cz.upol.reflect;

import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;

public class ReflectioExample {
	
	private static void showClassInfo(Class<?> clazz) {
		System.out.println(clazz);	
		
		System.out.println("\nFields:");
		Field[] fields = clazz.getDeclaredFields();
		for (Field field : fields)
			System.out.println(field.getName() + "\t-> " + Modifier.toString(field.getModifiers()) + " " + field.getType());
		
		System.out.println("\nMethods:");
		Method[] methods = clazz.getDeclaredMethods();
		for (Method method : methods) {
			System.out.println(method.getName());
		}
	}
	
	private static Object getEmployee(Class<?> clazz) throws InstantiationException, IllegalAccessException, SecurityException, NoSuchMethodException, IllegalArgumentException, InvocationTargetException {
		Object obj = clazz.newInstance();
		
		Method m;
		m = clazz.getMethod("setName", String.class);
		m.invoke(obj, "Tomas marny");
	
		return obj;
	}
	
	private static void modifyEmployee(Object obj) throws SecurityException, NoSuchMethodException, IllegalArgumentException, IllegalAccessException, InvocationTargetException {
		Method m = obj.getClass().getMethod("setAge", int.class);
		m.invoke(obj, 50);
	}
	
	public static void main(String[] args) throws Exception {
		
		Class<Employee> clazz = Employee.class;
		showClassInfo(clazz);
		
		Object obj = getEmployee(Employee.class);
		System.out.println(obj);
		modifyEmployee(obj);
		System.out.println(obj);
	}

}
